#include <stdio.h>
#include <stdlib.h>
// definiamo dei valori costanti
// utili nel programma
#define MASv 1e+20
#define MINv 1e-20
#define MASfile 102400  // 100 kbyte
#define MASwd 15  // 1 parola = 15 lettere
#define NOFwd 500  // 500 parole max
#define SHORT_D "short"
#define NOUNS_D "nouns"
#define VEAD_D "vead"
#define FOLDIC ".\\dic\\"
#define EXT_D ".txt"
#define OUTFI ".\\poem.txt"

char wds[3][NOFwd][MASwd];
int wds_readed[3];
int bitmask = 0xA5; // 5aa5
int maxblank = 3000;
int lupo = 60;
int verstr = 6;
int SHLf = 0; // 3
int outfil1 = 1;
int mthd = 1;

int LeggiFile(char *fname, char *content[], unsigned long *dimens);
int ScriviFile(char *fname, char *content[], unsigned long *dimens, int freecontent);
int LetBuf_Paro( char *buffer,  unsigned long bufsz,  unsigned int k);
void StampaPoema(unsigned long a, unsigned long b, unsigned long lenp);
void SettingsChange(void);

int main(int argc, char *argv[])
{
  char *buf;
  unsigned long bufsz,a,b;
  char buf3[255];
  int temp;
  
  //memset (wds,' ',sizeof(wds));
  sprintf(buf3,"%s%s%s",FOLDIC,SHORT_D,EXT_D);
  temp=LeggiFile(buf3,&buf,&bufsz); 
  if (temp>0) {
        printf( "Readed successfully %s!\n",buf3);
        // ... procedura di lettura di buf ...
        temp=LetBuf_Paro(buf,bufsz,0);
        free(buf);
        printf( "Words found = %d\n",wds_readed[0]);
  } else {
        printf( "Something gone wrong.\n");
        system("PAUSE");
        return 0;
  }      
  sprintf(buf3,"%s%s%s",FOLDIC,NOUNS_D,EXT_D);
  temp=LeggiFile(buf3,&buf,&bufsz); 
  if (temp>0) {
        printf( "Readed successfully %s!\n",buf3);
        // ... procedura di lettura di buf ...
        temp=LetBuf_Paro(buf,bufsz,1);
        free(buf);
        printf( "Words found = %d\n",wds_readed[1]);
  } else {
        printf( "Something gone wrong.\n");
        system("PAUSE");
        return 0;
  } 
  sprintf(buf3,"%s%s%s",FOLDIC,VEAD_D,EXT_D);
  temp=LeggiFile(buf3,&buf,&bufsz); 
  if (temp>0) {
        printf( "Readed successfully %s!\n",buf3);
        // ... procedura di lettura di buf ...
        temp=LetBuf_Paro(buf,bufsz,2);
        free(buf);
        printf( "Words found = %d\n",wds_readed[2]);
  } else {
        printf( "Something gone wrong.\n");
        system("PAUSE");
        return 0;
  } 
  if (wds_readed[0] < 5 || wds_readed[1] < 5 || wds_readed[2] < 5 ) {
        printf( "Something gone wrong, lists need at least 5 words each.\n");
        system("PAUSE");
        return 0;
  } 
  
  temp = 1;
  do {
      printf( "Type a number or zero to end or 876543 to change settings.\n");
      scanf ("%uld", &a); 
      if (a<=0) {
                temp = a;
                continue; // bail
                }
      if (a==876543) { 
                SettingsChange();
                continue; }
      printf( "Type another number.\n");
      scanf ("%uld", &b); 
      StampaPoema(a,b,lupo);
  } while (temp == 1);	
  printf( "Goodbye then.\n");
  system("PAUSE");
  return 0;
}

int LeggiFile(char *fname, char *content[], unsigned long *dimens)
{
    // legge il contenuto di un vettore di caratteri da un file binario.
        FILE *file;
        char *buffer;
        unsigned long fileLen;

        //Open file
        file = fopen(fname, "rb");
        if (!file)
        {
                printf("Error! File %s cannot be opened.\n", fname);
                *dimens = 0;
                *content = NULL;
                return -1;
        }
        
        //Get file length
        fseek(file, 0, SEEK_END);
        fileLen=ftell(file);
        fseek(file, 0, SEEK_SET);
        
        if (fileLen<MASfile) {
            //Allocate memory
            buffer=(char *)malloc(fileLen+2);
        } else {
           // FILE TROPPO GRANDE... USCIAMO
           buffer=NULL;
           }
        if (!buffer) {
           printf("Error! File %s too big!\n", fname);
           printf("Max length in bytes = %d\n", MASfile);
           fclose(file);
           //LiberaMem(1);
           exit (1);
           
        }

        //Read file contents into buffer
        
        fread(buffer, fileLen, 1, file);
        buffer[fileLen]=0; // deve finire con zero
        fclose(file);
        
        *content = buffer;
        *dimens = fileLen;
        return *dimens;
        // free(buffer);
}

int ScriviFile(char *fname, char *content[], unsigned long *dimens, int freecontent)
{
    // scrive il contenuto di un vettore di caratteri in un file binario.
    // Se il vettore non  allocato esce...
   FILE *file;
   unsigned long dim;
        if (*dimens==0 || *content == NULL)
        {
                return -1;
        }
        
   file = fopen(fname,"wb");
        if (!file)
        {
                printf("Error! File %s cannot be opened.\n", fname);
                return -1;
        }
   fwrite(*content,*dimens,1,file);
   fclose(file);
   dim = *dimens;
   
   // LIBERO IL VETTORE CONTENT
   if (freecontent) {
       free(*content);
       *dimens = 0;
       }
   return dim;
}

int LetBuf_Paro( char *buffer,  unsigned long bufsz,  unsigned int k)
{
  unsigned long id = 0;
  unsigned long coLe = 0;
  unsigned long coPa = 0;
  char nuCa;
  char veCa = 'a';
  wds_readed[k] = 0;
  
  do {
      nuCa = buffer[id];
      if ((nuCa >= '!' || nuCa <= '')) {
          if ((coLe < MASwd-2 )) {
                    wds[k][coPa][coLe] = buffer[id];
                    }
          coLe++;
          veCa = nuCa; 
      } else {
          if (veCa != 0) { 
                   // word is ended or invalid stuff
                  if (coLe >= MASwd-1 ) { coLe = MASwd-1; }
                  if ( coLe > 0 ) { 
                       wds[k][coPa][coLe] = 0; // null terminated string
                       coPa++; wds_readed[k]=wds_readed[k]+1;
                       } // else skip completely 
                  // invalid length = 0 sequences
                  coLe = 0; // next word ...
                  }
          veCa = 0;
      }
      id++;
    } while (id < bufsz && coPa < NOFwd);
    
    return wds_readed[0];
}

void StampaPoema(unsigned long a, unsigned long b, unsigned long lenp)
{
  unsigned long c = 0;
  unsigned long k = 0;
  unsigned long k1 = 0;
  unsigned long k2 = 0;
  unsigned long id = 0;
  FILE* outfile;
  if ( outfil1 ) {
       outfile = stdout;} else {
       printf("Poem is printed into %s\n" , OUTFI);
       outfile = fopen(OUTFI,"wb");
       if (!outfile)
        {
        printf("Error! File %s cannot be opened.\n", OUTFI);
        return;
        }       
  }
  fprintf(outfile, "*** Poem *** \r\n" );
  do {
      k2 = id % 5;
      k = 0;
      if (k2 == 0) {
          k1 = verstr;
          if ( k1 == 5 ) { k1= ((b >> 3) & 1) + 1; 
             } else if ( k1 == 6 ) { k1= ((b >> 3) & 1) + 3; }
      }
      switch (k1){
             case 1: {
                  if ( k2 == 1 ) { k=1; } else if ( k2 == 3 ) { k=2; }
                  break; }
             case 2: {
                  if ( k2 == 0 || k2 == 3 ) { k=1; } else if ( k2 == 1 ) { k=2; }
                  break; }
             case 3: {
                  if ( k2 == 3 ) { k=1; } else if ( k2 == 1 ) { k=2; }
                  break; }
             case 4: {
                  if ( k2 == 1 || k2 == 3 ) { k=1; } else if ( k2 == 0 ) { k=2; }
                  break; }
             default: {
                  k= b % 3;
                  break; }
             }
      c = (a * (b-a)) ^ bitmask; // this is the magic number.
      a = b; b = c & 0xFFFF;
      if (mthd == 1) {
         // the 'best' method
         c = ( c >> SHLf ) % (1 + wds_readed[k]);
      } else {
         // old method
         double cflo;
         cflo = ((double) wds_readed[k]) / ((double) 0xFFFF);
         cflo *= b;
         c = (int) cflo;
      }
      if ( b >= maxblank ) { 
         // fprintf(outfile, "%s[%d]", wds[k][c], c ); prints more info
         fprintf(outfile, "%s", wds[k][c] );
         if ( k2 != 4 ) { fprintf(outfile, " " ); }
         else { fprintf(outfile, "\r\n" ); }
      }
      id++;
    } while (id < lenp);
    fprintf(outfile, "\r\n*** Poem end *** \r\n" );
    if (!outfil1) fclose(outfile);
}

void SettingsChange(void)
{
  unsigned int q;
  printf( "Choose the word finding rule. (currently %d)\n", mthd);
  printf( "1) Rest of division. Almost uniform distribution of the words.\n");
  printf( "It's better to enable mask or the distribution may be less good.\n");
  printf( "2) Float division. Words on top and end of lists are rarely chosen.\n");
  printf( "Mask may have less impact.\n");
  printf( "The divider is not used with this method.\n");
  printf( "(1 to 2 or it will stay unchanged) ?");
  scanf ("%uld", &q); 
  if ( q >= 1 && q <= 2 ) mthd = q; 
  if (mthd != 2) {
      printf( "Type the new value for the divider. (currently %d)\n", SHLf);
      printf( "A formula variation factor. Zero disable.\n");
      printf( "This is a kind of 'cheat' to avoid cyclic sequences.\n");
      printf( "(0 to 16 or it will stay unchanged) ?");
      scanf ("%uld", &q); 
      if ( q < 16 ) SHLf = q;
      }
  printf( "Type the new value for the bit mask. (currently %d)\n", bitmask);
  printf( "Makes less predictable sequences - zero disable.\n");
  printf( "This is a kind of 'cheat' to avoid cyclic sequences.\n");
  printf( "Odd values are better, will break even-only ones.\n");
  printf( "Some values < 256 (like 165) are good if you like to see some words more often.\n");
  printf( "Some other (like 23205) tend to generate more random sequences.\n");
  printf( "(0 to 65535 or it will stay unchanged) ?");
  scanf ("%uld", &q); 
  if ( q < 0xFFFF ) bitmask = q;
  printf( "Type the new value for the blank limit. (currently %d)\n", maxblank);
  printf( "Bigger values for less regular verses or zero for const length.\n");
  printf( "(0 to 65535 or it will stay unchanged) ?");
  scanf ("%uld", &q); 
  if ( q < 0xFFFF ) maxblank = q;
  printf( "What phrase structure you would like? ( currently %d )\n", verstr);
  printf( "Where 'cw' is a very common word or a sign like '!'\n");
  printf( "and 'veat' is a verb or an attribute\n");
  printf( "The blank limit may affect the verse structure\n");
  printf( "1) cw noun cw veat cw\n");
  printf( "2) noun veat cw noun cw\n");
  printf( "3) cw veat cw noun cw\n");
  printf( "4) veat noun cw noun cw\n");
  printf( "5) variable, 1 or 2\n");
  printf( "6) variable, 3 or 4\n");
  printf( "7) No scheme at all\n");
  printf( "(1 to 7 or it will stay unchanged) ?");
  scanf ("%uld", &q); 
  if ( q >= 1 && q <= 7 ) verstr = q;
  printf( "How many words in each poem? ( currently %d )\n", lupo);
  printf( "(5 to 5000 or it will stay unchanged) ?");
  scanf ("%uld", &q); 
  if ( q >= 5 && q <= 5000 ) lupo = q;
  printf( "Throw the poem into POEM.TXT ? Zero = YES.\n");
  scanf ("%uld", &outfil1); 
}
